/*
 * Waypoin.cpp
 *
 *  Created on: 09/10/2012
 *      Author: felix
 */



/*
 * Waypoin.cpp
 *
 *  Created on: 22/11/2012
 *      Author: Felix Caro
 */
#include "Waypoin.h"

/**
 * Construtores
 */



Waypoin::Waypoin() {

	width = this->width;
	height = this->height;
	total = this->total;
	metrosYtotal = this->metrosYtotal;
	metrosXtotal = this->metrosXtotal;
	metrosYreconocidos = this->metrosYreconocidos;
	metrosXreconocidos = this->metrosXreconocidos;
	casillaLibre = true;
	ladopiselPixel = this->ladopiselPixel;
	centroPixelXY = this->centroPixelXY;
	p_entera = this->p_entera;
	alto = this->alto;
	ancho = this->ancho;
	resolution = this->resolution;
	rutaFicheroXML = this->rutaFicheroXML;
	data = this->data;
	waypoins = this->waypoins;
	contadorllamadas = this->contadorllamadas;
	waypoins = this->waypoins;
	tamanyoX_explora = this->tamanyoX_explora;
	tamanyoY_explora = this->tamanyoY_explora;
	mapacompletado = this->mapacompletado;
	metros2reconocidos = this->metros2reconocidos;
	mensaje_pub = this->mensaje_pub;

	// TODO Auto-generated constructor stub

}

Waypoin::~Waypoin() {
	// TODO Auto-generated destructor stub
}


/**
 * Metodos
 */
/**
 * metodo que aproxima a un determinado numero de decimales
 */
double round(double r, int n_digit) {
	int n = pow(10, n_digit);
	r = ((double) ((int) (r * n + 0.5))) / n;
	return (r);
}

/**
 * metodo que obtiene una division entera para las celdas en las que se va a dividir el mapa
 */
void Waypoin::divisiones() {

	/*la division tiene que ser multiplo de ladopisel*/
	//ROS_ERROR( "divisiones[%.8F, %.8F] ", metrosYtotal, metrosXtotal);
	division.divisionX = (floor(division.divisionX / ladopiselPixel))
			* ladopiselPixel;
	division.divisionY = (floor(division.divisionY / ladopiselPixel))
			* ladopiselPixel;
	//ROS_ERROR("dicision %.8F,%.8F",division.divisionX/ladopiselPixel,division.divisionY);



}
/**
 * obtiene el centro de la celda en la que se ha dividio el mapa, este punto sera el que marque el waypoin.
 */
void Waypoin::obtencionCentroCelda() {

	posicion.centroX = (division.divisionX / 2) + centroPixelXY;
	posicion.centroY = (division.divisionY / 2) + centroPixelXY;

}
/**
 * En este metodo se recorre el mapa pixel por pixel y se obtiene las celdas que estan vacias, para marcarlas con un waypoin
 *
 */
void Waypoin::transformaMapa() {

	int n_waypoin = 0;
	int n_celda = 1;
	int n_cuadriculas = 0;
	int nocupadas = 0;
	int ocupadas = 0;
	int nreconocidas = 0;
	double floorX = division.divisionX / ladopiselPixel;
	double floorY = division.divisionY / ladopiselPixel;

	metrosXreconocidos = 0;
	metrosYreconocidos = 0;
	metros2reconocidos = 0;

	for (int y = 0; y < alto; y++) {
		for (int x = 0; x < ancho; x++) {
			//con esto recorremos desde la esquina inferior izquierda,que sera la posicion (0,0)
			unsigned int i = x + (alto - y - 1) * ancho;

			if (data[i] == 0) { //occ [0,0.1)//no ocupado
				nocupadas++;
				nreconocidas++;
				//ROS_ERROR("LIBRE");
			} else if (data[i] == +100) { //occ (0.65,1] //ocupado
				ocupadas++;
				nreconocidas++;
				//ROS_ERROR("OCUPADA");
			} else { //occ [0.1,0.65] //desconocido
				//ROS_ERROR("DESCONOCIDA");
			}

			n_cuadriculas++;

			if ((y % ((int) floorY) == 0) && (x % ((int) floorX) == 0) ) {

				double metrosX = x * ladopiselPixel;
				double metrosY = y * ladopiselPixel;

				if (n_cuadriculas == nocupadas) {
					n_waypoin++;

					if (contadorllamadas == 0) {

						Waypoins waypoin;
						waypoin.n_waypoin = n_waypoin;
						waypoin.posicioncentroMX = metrosX - posicion.centroX;
						waypoin.posicioncentroMY = metrosY - posicion.centroY;
						waypoins.push_back(waypoin);



					} else {

						bool waypoin_new = true;

						for (std::list<Waypoins>::iterator it =
								waypoins.begin(); it != waypoins.end(); ++it) {
							if (it->n_waypoin == n_waypoin) {
								waypoin_new = false;
								if ((it->posicioncentroMX
										!= posicion.centroX * n_celda)
										|| (it->posicioncentroMY
												!= posicion.centroY * n_celda)) {
									Waypoins waypoin;
									waypoin.n_waypoin = n_waypoin;
									waypoin.posicioncentroMX = metrosX
											- posicion.centroX;
									waypoin.posicioncentroMY = metrosY
											- posicion.centroX;
									waypoin.celdaposX = division.divisionX
											* n_celda;
									waypoin.celdaposY = division.divisionY
											* n_celda;
									it = waypoins.erase(it);
									waypoins.insert(it, waypoin);
									break;

								} else {
									break;

								}
							} else {
								continue;

							}

						}
						if (waypoin_new == true) {
							Waypoins waypoin;
							waypoin.n_waypoin = n_waypoin;
							waypoin.posicioncentroMX = metrosX
									- posicion.centroX;
							waypoin.posicioncentroMY = metrosY
									- posicion.centroX;
							waypoin.celdaposX = division.divisionX * n_celda;
							waypoin.celdaposY = division.divisionY * n_celda;
							waypoins.push_back(waypoin);
						}

					}


					metrosXreconocidos = metrosXreconocidos + division.divisionX;
					metrosYreconocidos = metrosYreconocidos + division.divisionY;
					//ROS_ERROR("metros cuadrados %.8F,%.8F",metrosXreconocidos, metrosYreconocidos);

				} else if (n_cuadriculas == ocupadas) {

					metrosXreconocidos = metrosXreconocidos + division.divisionX;
					metrosYreconocidos = metrosYreconocidos + division.divisionY;
					//ROS_INFO("OCUPADO");
				} else {
					//ROS_INFO("DESCONOCIDO");
				}

				nocupadas = 0;
				ocupadas = 0;
				n_cuadriculas = 0;

				n_celda++;

			}
		}
	}

	//ROS_ERROR("data[%.8F, %i] ", resolution, nreconocidas);
	metros2reconocidos = resolution * nreconocidas;


}
/**
 * metodo que establece las conexiones entre waypoins la formula de la distancia euclidea
 */
void Waypoin::estableceConexiones() {

	std::list<Waypoins>::iterator it = waypoins.begin();
	while (it != waypoins.end()) {
		Waypoins waypoin;
		waypoin.n_waypoin = it->n_waypoin;
		waypoin.posicioncentroMX = it->posicioncentroMX;
		waypoin.posicioncentroMY = it->posicioncentroMY;
		for (std::list<Waypoins>::iterator it2 = waypoins.begin();
				it2 != waypoins.end(); it2++) {
			if ((((it->posicioncentroMX == it2->posicioncentroMX)
					&& !(it->posicioncentroMY >= (2 * it2->posicioncentroMY)))
					|| ((it->posicioncentroMY
							== (it2->posicioncentroMY - division.divisionY))
							&& (it->posicioncentroMX
									== (it2->posicioncentroMY
											- division.divisionX)))
					|| ((it->posicioncentroMY
							== (it2->posicioncentroMY + division.divisionY))
							&& (it->posicioncentroMX
									== (it2->posicioncentroMY
											+ division.divisionX)))
					|| ((it->posicioncentroMY
							== (it2->posicioncentroMY + division.divisionY))
							&& (it->posicioncentroMX
									== (it2->posicioncentroMY
											- division.divisionX)))
					|| ((it->posicioncentroMY
							== (it2->posicioncentroMY - division.divisionY))
							&& (it->posicioncentroMX
									== (it2->posicioncentroMY
											+ division.divisionX)))
					|| ((it->posicioncentroMY == it2->posicioncentroMY)
							&& !(it->posicioncentroMX
									>= (2 * it2->posicioncentroMX))))
					&& (it->n_waypoin != it2->n_waypoin)) {

				Conexiones conexion;
				conexion.distancia = sqrt(
						pow((it->posicioncentroMX - it2->posicioncentroMX), 2)
								+ pow(
										(it->posicioncentroMY
												- it2->posicioncentroMY), 2));// distancia euclidea entre el centro de las dos cuadriculas
				conexion.waypoinConexion = it2->n_waypoin;

				waypoin.conexiones.push_back(conexion);	// almacena en la lista de conexiones de un waypoin.

			} else {
				continue;
			}
		}
		//waypoins.remove(waypoin);
		it = waypoins.erase(it);
		waypoins.insert(it, waypoin);//actuliza la informacion del nodo de la lista de informacion del waypoin.

	}

}
/**
 * Metodo que construye el fichero .xml donde se guardara la informacion del dominio con los waypoins y la posicion inicial del mapa.
 * Este metodo utiliza la libreria TinyXml
 */
void Waypoin::buildDomainXml() {

	TiXmlDocument doc;

	TiXmlDeclaration * decl = new TiXmlDeclaration("1.0", "", "");
	//Dominio
	TiXmlElement * element = new TiXmlElement("Map");
	doc.LinkEndChild(decl);
	doc.LinkEndChild(element);

	TiXmlText * text = new TiXmlText("Pioneer3DX-Mapa");
	element->LinkEndChild(text);

	TiXmlElement * element3 = new TiXmlElement("Datos_Mapa");
	 element->LinkEndChild(element3);
	 element3->SetAttribute("structure", "Mapa-domain");
	 element3->SetAttribute("name", "Mapa-domain");
	 element3->SetAttribute("units", "metros");
	 element3->SetDoubleAttribute("y", metrosYtotal);
	 element3->SetDoubleAttribute("x", metrosXtotal);
	 element3->SetDoubleAttribute("area", metrosYtotal * metrosXtotal);
	 element3->SetDoubleAttribute("area_covered", metros2reconocidos);

	TiXmlElement * element2 = new TiXmlElement("robot");
	 element->LinkEndChild(element2);
	 element2->SetAttribute("name", "Pioneer3DX");
	 element2->SetDoubleAttribute("x", posicionOrientacionRobot.posicionX);
	 element2->SetDoubleAttribute("y", posicionOrientacionRobot.posicionY);
	 element2->SetDoubleAttribute("orientacion_x", posicionOrientacionRobot.orientacionX);
	 element2->SetDoubleAttribute("orientacion_y", posicionOrientacionRobot.orientacionY);
	 element2->SetDoubleAttribute("orientacion_w", posicionOrientacionRobot.orientacionW);

	//Waypoins
	std::list<Waypoins>::iterator it = waypoins.begin();
	while (it != waypoins.end()) {

		TiXmlElement * element1 = new TiXmlElement("waypoin");
		element->LinkEndChild(element1);
		element1->SetAttribute("code", it->n_waypoin);
		element1->SetDoubleAttribute("posicion_X", it->posicioncentroMX);
		element1->SetDoubleAttribute("posicion_Y", it->posicioncentroMY);

		for (std::list<Conexiones>::iterator it2 = it->conexiones.begin();
				it2 != it->conexiones.end(); it2++) {

			TiXmlElement * element2 = new TiXmlElement("connection");
			element1->LinkEndChild(element2);
			element2->SetAttribute("code", it2->waypoinConexion);
			element2->SetDoubleAttribute("distance", it2->distancia);
		}
		it++;
	}

	//ROS_ERROR("ruta fichero: %s",rutaFicheroXML.c_str());
	//ROS_ERROR("ruta fichero");
	///home/felix/ros_workspace/proyecto/mapas/DomainMapaPDDL.xml

	if(doc.SaveFile(rutaFicheroXML.c_str())==false){
		ROS_ERROR("PROBLEMA GUARDANDO LOS DATOS EN EL FICHERO .xml");
	}

	TiXmlPrinter printer;
	doc.Accept(&printer);
	mensaje_pub = printer.CStr();

	/*FILE *fichero;
	fichero = fopen(rutaFicheroXML.c_str(), "w");
	fprintf(fichero, mensaje_pub);
	fclose(fichero);*/
}

void Waypoin::Callback(const nav_msgs::OccupancyGrid::ConstPtr& map) {

	//ROS_ERROR("Estoy en Callback");

	while ( mapacompletado != true) {
		//ROS_ERROR("Estoy WHILE");

		if ((metrosXreconocidos >= tamanyoX_explora) && (metrosYreconocidos >= tamanyoY_explora)) {

			//ROS_ERROR("mapa_completado");
			estableceConexiones();
			buildDomainXml();
			mapacompletado = true;
			break;

		} else {

			if (contadorllamadas == 0) {
				alto = map->info.height;
				ancho = map->info.width;
				resolution = map->info.resolution;
				data = map->data;

				//map->data info.origin.orientation

				ladopiselPixel = sqrt(resolution);//dado que un pixel cuadrado el lado de un pixel sera la capacidad, lo unico que cambia es m2 a m
				centroPixelXY = ladopiselPixel / 2;
				metrosYtotal = ladopiselPixel * alto;
				metrosXtotal = ladopiselPixel * ancho;

				posicionOrientacionRobot.posicionX = map->info.origin.position.x*(-1);//el menos uno es para trasfromarlo ya que nosostros recorremos el bucle de
				posicionOrientacionRobot.posicionY = map->info.origin.position.y*(-1);
				posicionOrientacionRobot.orientacionX = map->info.origin.orientation.x*(-1);
				posicionOrientacionRobot.orientacionY = map->info.origin.orientation.y*(-1);
				posicionOrientacionRobot.orientacionW = map->info.origin.orientation.w*(-1);

				if (!(tamanyoX_explora <= metrosXtotal)) {
					tamanyoX_explora = 50;
					ROS_ERROR(
							"El tamaño a explora de x debe de ser < de %.8F, se establecera por defecto 50 metros", ladopiselPixel * ancho);
				}

				if (!(tamanyoY_explora <= metrosYtotal)) {
					tamanyoY_explora = 100;
					ROS_ERROR(
							"El tamaño a explora de y debe de ser < de %.8F, se establecera por defecto 100 metros", ladopiselPixel * alto);
				}
				divisiones();
				obtencionCentroCelda();
				//ROS_ERROR("voy hacer el primer transfoma mapa");
				transformaMapa();
				estableceConexiones();
				buildDomainXml();
				contadorllamadas++;

			} else {
				//ROS_ERROR("SEGUNDA");
				transformaMapa();
				estableceConexiones();
				buildDomainXml();
				contadorllamadas++;
				continue;


			}



		}

	}

}

/**
 * Este metodo se encarga de recibir los parametros de entrada del nodo waypoin, y ver que son los correctos. Si estos no son correctos se dara un mensaje de
 * de error o se establecera un parametro por defecto.
 */

bool Waypoin::trataArgumentos(ros::NodeHandle Wn) {

	std::string rutaFichero;
	double divisionMapaCudriculaY, divisionMapaCudriculaX, tamanyo_X_explorar,
			tamanyo_Y_explorar;
	bool respuesta = true;

	try {
		if (Wn.getParam("/waypoin/rutaFichero", rutaFichero)) {
			//ROS_ERROR("fich \"%s\"\n", rutaFichero.c_str());
			//ROS_ERROR("Hay un error");
			rutaFicheroXML = rutaFichero;
			if (Wn.getParam("/waypoin/AltoCeldas", divisionMapaCudriculaY)) {
				division.divisionY = divisionMapaCudriculaY;

			} else {
				division.divisionY = 0.5;
			}

			if (Wn.getParam("/waypoin/AnchoCeldas", divisionMapaCudriculaX)) {
				division.divisionX = divisionMapaCudriculaX;
			} else {
				division.divisionX = 0.5;
			}
			if (Wn.getParam("/waypoin/TamanyoX_explorar", tamanyo_X_explorar)) {
				tamanyo_X_explorar = tamanyoX_explora;
			} else {

				tamanyoX_explora = 200;
			}

			if (Wn.getParam("/waypoin/TamanyoY_explorar", tamanyo_Y_explorar)) {
				tamanyo_Y_explorar = tamanyoY_explora;
			} else {
				tamanyoY_explora = 200;
			}

		} else {
			ROS_ERROR("Ruta erronea");
			return respuesta;
		}

	} catch (char * str) {
		cout << "Exception raised: " << str << '\n';
		respuesta = false;
	}

	return respuesta;
}

int main(int argc, char** argv) {

	ros::init(argc, argv, "/waypoin"); //inicializacion del nodo waypoin.

	ros::NodeHandle Wn;
	ros::Publisher pub;
	Waypoin waypoin;
	proyecto::Xml_waypoins respuesta_xml;

	if (waypoin.trataArgumentos(Wn) == false) {
		return -1;

	} else {

		ros::Subscriber map_subcriber = Wn.subscribe("/map", 1000, &Waypoin::Callback,&waypoin);
		ros::Rate loop_rate(10);
		pub = Wn.advertise<proyecto::Xml_waypoins>("/waypoin", 1, true);
		std_msgs::String msg;
		waypoin.contadorllamadas=0;
		waypoin.mapacompletado=false;

		while (ros::ok()){

			respuesta_xml.time_publisher= ros::Time();
			respuesta_xml.mensaje_pub = waypoin.getMensajePub();
			respuesta_xml.terminado_mapeo = waypoin.isMapacompletado();
			pub.publish(respuesta_xml);
			ros::spinOnce();
			loop_rate.sleep();

		}

		ros::spin();
		return 0;
	}
	/* establece subcriber de mapas de un tamaño definido, publisher que lance todo  y subcriber que navegue mover**/

}
