#include <ros/ros.h>
#include "nav_msgs/GetMap.h"
#include "nav_msgs/MapMetaData.h"
#include "nav_msgs/OccupancyGrid.h"
#include "std_msgs/String.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void mapCallback(const nav_msgs::OccupancyGrid::ConstPtr& map)
{
	
  	//map->Point.position.y;
        int width = 0;
	int height = 0;
	int ocupadas = 0;
	int nocupadas = 0;
	int desconocidas = 0;
	int total = 0;
	int divisionY = 20;
	int divisionX = 20;
	int metrosY = 0;
	int metrosX = 0;
	bool casillaLibre = true;
        double ladopiselPixel = sqrt(map->info.resolution);//la resolucion son m/pixel
	double centroPixelXY = ladopiselPixel/2;// al ser cuadrado un pixel, el centro de este, esta a la misma distacia de los ejes X e Y
	
	if ( ((map->info.height) % 20 == 0) && ((map->info.width) % 20 == 0) ){
		divisionY = 20;
		divisionX = 20;
	}else{
		if (! (((map->info.height)% 20) == 0) ){
			for(unsigned int y = 0; y < 20; y++) {
				divisionY = divisionY -1;
				if ((map->info.height)% divisionY == 0){
					break;
				}
			}
		} 
		if (! (((map->info.width)% 20) == 0)){
			for(unsigned int x = 0; x < 20; x++) {
				divisionX = divisionX -1;
				if ((map->info.width)% divisionX == 0){
					break;
				}
			}
		}
	}
	ROS_INFO("y-> %d",divisionY);
	ROS_INFO("x-> %d",divisionX);
	int n_cuadriculas = 0;// pixeles de nuestra celda
        // se calcula los  centros de las cuadriculas nuestras.
	//divisiones impares en Y y en X
        double  p_entera;
	double centroX;
	double centroY;
	if(! ((divisionY % 2 == 0) && (divisionX % 2 == 0)) ){
		double lineaX = modf((divisionX/2), &p_entera);
		double centroX =  (p_entera * ladopiselPixel) +  centroPixelXY;
		p_entera = 0;
        	double lineaY = modf((divisionY/2), &p_entera);  
        	double centroY =  (p_entera * ladopiselPixel) +  centroPixelXY;
		p_entera = 0;
		ROS_INFO("Received centro de las cuadriculas estaran1 [%.8F, %.8F] ",centroX,centroY);
	}else if (!(divisionY % 2 == 0)){//divisiones impares en Y;
		double centroX = ( (map->info.height/ divisionX)  / 2) * ladopiselPixel;
        	double lineaY = modf((divisionY/2), &p_entera);  
        	double centroY =  (p_entera * ladopiselPixel) +  centroPixelXY;
		p_entera = 0;
		ROS_INFO("Received centro de las cuadriculas estaran2 [%.8F, %.8F] ",centroX,centroY);
	}else if (!(divisionX % 2 == 0)){//divisiones impares en X
		double lineaX = modf((divisionX/2), &p_entera);
		double centroX =  (p_entera * ladopiselPixel) +  centroPixelXY;
		p_entera = 0; 
        	double centroY = ( (map->info.height/ divisionX)  / 2) * ladopiselPixel;
		ROS_INFO("Received centro de las cuadriculas estaran 3[%.8F, %.8F] ",centroX,centroY);
	}else{//divisiones impares en ninguno.
		double centroX =  ( (map->info.width/ divisionX)  / 2) * ladopiselPixel; 
        	double centroY =  ( (map->info.height/ divisionY)  / 2) * ladopiselPixel;
		ROS_INFO("Received centro de las cuadriculas estaran 4[%.8F, %.8F] ",centroX,centroY);
        }

	

	
	for(unsigned int y = 0; y < map->info.height; y++) {
		for(unsigned int x = 0; x < map->info.width; x++) {
			unsigned int i = x + (map->info.height - y - 1) * map->info.width;
			if (map->data[i] == 0) { //occ [0,0.1)//no ocupado
            			nocupadas++;
			} else if (map->data[i] == +100) { //occ (0.65,1] //ocupado
                		ocupadas++;
			} else { //occ [0.1,0.65] //desconocido
				desconocidas++;
			}
		
			n_cuadriculas++;

			// Vamos a etiquetar las celdas de nuestra regilla como ocupadas, no ocupadas, o desonocido. 
			if((y % divisionY == 0) && (x % divisionX == 0)){
				//calculamos metros en el los que se encuentra la cuadridulael centro de nuestra cuadricula
				int metrosY = ladopiselPixel * y;
				int metrosX = ladopiselPixel * x;
				if(n_cuadriculas == nocupadas){
					ROS_INFO("LIBRE");                                
					ROS_INFO("Position: [%.8F, %.8F]",metrosX - centroX  , metrosY - centroY);

				}else if(n_cuadriculas == ocupadas){
					ROS_INFO("OCUPADO");
				}else{	
					ROS_INFO("DESCONOCIDO");
				}
				nocupadas = 0;
				ocupadas = 0;
				ocupadas = 0;
				n_cuadriculas = 0;

			}
			
	
		}
		
	}
	ROS_INFO("Received a %d X %d map @ %.3f m/pix",map->info.width,map->info.height,map->info.resolution);
	ROS_INFO("Received a en metros %.8F X %.8F map @ %.8F lado pixel",map->info.width * ladopiselPixel, map->info.height * ladopiselPixel, ladopiselPixel);
}



int main(int argc, char** argv){
	ros::init(argc, argv, "Mapas");
	ros::NodeHandle n;

  
  //subscribe to map info
	ros::Subscriber map_sub = n.subscribe< nav_msgs::OccupancyGrid>("/map", 1000, mapCallback);

	ros::spin();
}
