/*
 * Navigation.cpp
 *
 *  Created on: 29/01/2013
 *      Author: felix
 */

#include "Navigation.h"

Navigation::Navigation() {
	goal_thet= this->goal_thet;
	goal_x= this->goal_x;
	goal_y= this->goal_y;
	pose_x = this->pose_x;
	pose_y = this->pose_y;
	pose_thet = this->pose_thet;
	pose_orientation_x = this->pose_orientation_x;
	pose_orientation_y = this->pose_orientation_y;
	pose_orientation_z = this->pose_orientation_z;
	waypoin_inicio = this->waypoin_inicio;
	waypoin_meta = this->waypoin_meta;
	rutaFicheroXMLWaypoins = this->rutaFicheroXMLWaypoins;
	// TODO Auto-generated constructor stub

}

Navigation::~Navigation() {
	// TODO Auto-generated destructor stub
}



bool atGoal = false;
geometry_msgs::TransformStamped geo_pose;

void Navigation::getwaypoins(){
	TiXmlDocument doc(rutaFicheroXMLWaypoins);
	if(doc.LoadFile()==true)
	{
		TiXmlNode* node = 0;

		 node = doc.FirstChild( "Map" );
		 int cont=1;
		 TiXmlElement* example2 = node->FirstChildElement();
		 assert( node );
		 TiXmlElement* todoElement = 0;
		 TiXmlElement* itemElement = 0;
		 todoElement = node->ToElement();

		 assert( todoElement  );
		 node = todoElement->FirstChildElement("robot");
		 assert( node );

		 itemElement = node->ToElement();
		 assert(itemElement);
		 double inicial_y;
		 double inicial_x;
		 double inicial_z;
		 double orientacion_x;
		 double orientacion_y;
		 double orientacion_w;

		 itemElement->Attribute("y", &inicial_y);
		 itemElement->Attribute("x", &inicial_x);
		 itemElement->Attribute("z", &inicial_z);
		 itemElement->Attribute("orientacion_x", &orientacion_x);
		 itemElement->Attribute("orientacion_y", &orientacion_y);
		 itemElement->Attribute("orientacion_w", &orientacion_w);

		 pose_x = inicial_x;
		 pose_y =inicial_y;
		 pose_thet = inicial_z;

		 pose_orientation_x = orientacion_x;
		 pose_orientation_y = orientacion_y;
	     pose_orientation_z = orientacion_w;

		 node = todoElement->FirstChild("waypoin");
		 itemElement = node->ToElement();
		 while(itemElement != NULL ){
			 assert(itemElement);
				 int code;
				 double inicial_x;
				 itemElement->Attribute("code",&code);
				 if (waypoin_meta == code){
		    		   double gx;
		    		   double gy;
					 itemElement->Attribute("posicion_X",&gx);
					 itemElement->Attribute("posicion_Y",&gy);
					 goal_x= gx;
					 goal_y= gy;
					 //goal_y= 0.608;
					 goal_thet =  0.222;
					/* goal_x = 5.3;
					 goal_y = -4.306;*/
				 }
				 itemElement = itemElement->NextSiblingElement();
		 }


	}


}
void sendGoal(double x, double y, double theta, Publisher pub){
  //tf::Stamped<tf::Pose> p = tf::Stamped<tf::Pose>(tf::Pose(tf::createQuaternionFromYaw(theta), tf::Point(x, y, 0.0)), ros::Time::now(), panel_->getGlobalFrame());
  geometry_msgs::PoseStamped goal;
  //tf::poseStampedTFToMsg(p, goal);
  //ROS_DEBUG("setting goal: Position(%.3f, %.3f, %.3f), Orientation(%.3f, %.3f, %.3f, %.3f) = Angle: %.3f\n", goal.pose.position.x, goal.pose.position.y, goal.pose.position. z, goal.pose.orientation.x, goal.pose.orientation.y, goal.pose.orientation.z, goal.pose.orientation.w, angle);

  goal.pose.position.x = x;
  goal.pose.position.y = y;
  goal.pose.position.z = theta;
  btQuaternion temp;
  temp.setEulerZYX(theta,0,0);
  goal.pose.orientation.x = temp.getX();
  goal.pose.orientation.y = temp.getY();
  goal.pose.orientation.z = temp.getZ();
  goal.pose.orientation.w = temp.getW();
  goal.header.stamp = ros::Time::now();
  goal.header.frame_id = "/map";//panel_->getGlobalFrame();
  //ROS_ERROR("Meta esta:[%.8F,%.8F,%.8F,]",x, y, theta);
  pub.publish(goal);
}

void getPose(tf::TransformListener* listener, double* x, double* y, double* th){
  tf::StampedTransform transform;
  try{
    listener->lookupTransform("/map", "/base_link", ros::Time(0), transform);
  }
  catch (const tf::TransformException & ex){
  ROS_ERROR("%s",ex.what());
  }

  transformStampedTFToMsg(transform, geo_pose);

  *x = geo_pose.transform.translation.x;
  *y = geo_pose.transform.translation.y;
  *th = tf::getYaw(geo_pose.transform.rotation);
}

void sendPose(double x, double y, double theta, Publisher pub){
  //tf::Stamped<tf::Pose> p = tf::Stamped<tf::Pose>(tf::Pose(tf::createQuaternionFromYaw(theta), tf::Point(x, y, 0.0)), ros::Time::now(), panel_->getGlobalFrame());
  geometry_msgs::PoseWithCovarianceStamped goal;
  //tf::poseStampedTFToMsg(p, goal);
  //ROS_DEBUG("setting goal: Position(%.3f, %.3f, %.3f), Orientation(%.3f, %.3f, %.3f, %.3f) = Angle: %.3f\n", goal.pose.position.x, goal.pose.position.y, goal.pose.position. z, goal.pose.orientation.x, goal.pose.orientation.y, goal.pose.orientation.z, goal.pose.orientation.w, angle);
  goal.pose.pose.position.x = x;
  goal.pose.pose.position.y = y;
  goal.pose.pose.position.z = 0;
  btQuaternion temp;
  temp.setEulerZYX(theta,0,0);
  goal.pose.pose.orientation.x = temp.getX();
  goal.pose.pose.orientation.y = temp.getY();
  goal.pose.pose.orientation.z = temp.getZ();
  goal.pose.pose.orientation.w = temp.getW();
  goal.header.stamp = ros::Time::now();
  goal.header.frame_id = "/map";//panel_->getGlobalFrame();
  //ROS_ERROR("initialpose1");
  pub.publish(goal);

}

bool Navigation::trataArgumentos(ros::NodeHandle n) {

	std::string rutaFichero;
	int waypoin_i, waypoin_m;
	bool respuesta = true;

	try {
		if (n.getParam("/Navigation/rutaFichero", rutaFichero)) {
			//ROS_ERROR("fich \"%s\"\n", rutaFicahero.c_str());

			rutaFicheroXMLWaypoins = rutaFichero;
			if (n.getParam("/Navigation/inicio", waypoin_i)) {
				waypoin_inicio = waypoin_i;

			} else {
				waypoin_inicio = 1;
			}

			if (n.getParam("/Navigation/meta", waypoin_m)) {
				waypoin_meta = waypoin_m;
			} else {
				waypoin_meta = 2;
			}


		} else {
			ROS_ERROR("Ruta erronea");
			return respuesta;
		}

	} catch (char * str) {
		cout << "Exception raised: " << str << '\n';
		respuesta = false;
	}

	return respuesta;
}


int main(int argc, char** argv){
  ros::init(argc, argv, "Navigation_waypoins");

  Navigation navigation;
  Publisher robotGoal = ros::NodeHandle().advertise<geometry_msgs::PoseStamped>("move_base_simple/goal", 1);
  Publisher robotStart = ros::NodeHandle().advertise<geometry_msgs::PoseWithCovarianceStamped>("/initialpose", 1);
  ros::Rate loop_rate(1);
  ros::NodeHandle n;
  if (navigation.trataArgumentos( n ) == false) {
		return -1;
		 //ROS_ERROR("ENVIANDO META");
} else {

	 // tf::TransformListener listener;
	  sleep(10.0);
	  navigation.getwaypoins();
	  //sendPose(navigation.pose_x, navigation.pose_y, navigation.pose_thet, robotStart);
	  //double t = ros::Time::now().toSec();
	 //double x,y,th;

//  while(n.ok()){
    //t = ros::Time::now().toSec();

    //ROS_ERROR("ENVIANDO META");
    sendGoal(navigation.goal_x, navigation.goal_y, navigation.goal_thet, robotGoal);
    ROS_ERROR("Meta esta:[%.8F,%.8F,%.8F,]",navigation.goal_x, navigation.goal_y, navigation.goal_thet);
    ros::spinOnce();
    loop_rate.sleep();
    /*while(n.ok() && ros::Time::now().toSec()-t < 180.0 && !atGoal){

     getPose(&listener,&x,&y,&th);
     double dx = navigation.pose_x-x;
     double dy = navigation.pose_y-y;
     double dist = sqrt(dx*dx+dy*dy);
     atGoal = dist < 1.0;
     ros::Duration(1.0).sleep();

   }

   t = ros::Time::now().toSec();
    atGoal = false;
    sendGoal(navigation.goal_x, navigation.goal_y, navigation.goal_thet, robotGoal);
    while(n.ok() && ros::Time::now().toSec()-t < 180.0 && !atGoal){

      getPose(&listener,&x,&y,&th);
      double dx = navigation.goal_x-x;
      double dy =  navigation.goal_y-y;
     double dist = sqrt(dx*dx+dy*dy);
     atGoal = dist < 1.0;
      ros::Duration(1.0).sleep();
    }*/
 // }

  ros::spin();

	}
}

/*int main(int argc, char **argv)
{
ros::init(argc, argv, "goal_publisher");
ros::NodeHandle n;
ros::Publisher goal_pub = n.advertise<geometry_msgs::PoseStamped>("/move_base_simple/goal", 1);
ros::Rate loop_rate(1);
geometry_msgs::PoseStamped msg;
if (argc != 3)
{
ROS_INFO("Please provide x and y of the goal!");
}
msg.header.frame_id = "/map";
msg.pose.position.x = atol(argv[1]);
msg.pose.position.y = atol(argv[2]);
msg.pose.position.z = 0.0;
msg.pose.orientation.x = 0.0;
msg.pose.orientation.y = 0.0;
msg.pose.orientation.z = 0.0;
msg.pose.orientation.w = 1.0;
ROS_INFO("Sending Robot to %f, %f", msg.pose.position.x, msg.pose.position.y);
goal_pub.publish(msg);
ros::spinOnce();
loop_rate.sleep();
return 0;
}
 * */
