/*
 * Waypoin.h
 *
 *  Created on: 09/10/2012
 *      Author: felix
 */

#ifndef WAYPOIN_H_
#define WAYPOIN_H_

#include "nav_msgs/GetMap.h"
#include "nav_msgs/MapMetaData.h"
#include "nav_msgs/OccupancyGrid.h"
#include "std_msgs/String.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "tinyxml/tinyxml.h"
#include "geometry_msgs/Quaternion.h"
#include <vector>
#include <ros/ros.h>
#include <iostream>
#include <iterator>
#include <signal.h>
#include <termios.h>
#include "proyecto/Xml_waypoins.h"
#include <iostream>
#include <fstream>

using namespace std;

class Waypoin {

public:

	Waypoin();
	virtual ~Waypoin();

public:

	int width;
	int height;
	int total;
	int contadorllamadas;
	double metrosYreconocidos;
	double metrosXreconocidos;
	double metrosYtotal;
	double metrosXtotal;
	bool casillaLibre; // muestra si la celda de la regilla esta libre de obstaculos
	double ladopiselPixel; //la resolucion son m/pixel
	double centroPixelXY; //posicion del centro del pixel de la imagen
	double p_entera; //parte entera de la division del lado de una celda de la rejilla
	int alto;
	int ancho;
	float resolution;
	std::string rutaFicheroXML;
	std::vector<int8_t> data;
	double tamanyoX_explora;
	double tamanyoY_explora;
	double metros2reconocidos;
	bool mapacompletado;

	const char * mensaje_pub;


	//TiXmlElement * element1;




	struct PosicionCentro {
		double centroX, centroY; // posicion X del centro de la celda de la rejilla
	} posicion;

	struct DivisionesCuadricula{
		double divisionX, divisionY; // posicin X del centro de la celda de la rejilla
	} division;

	struct Conexiones{
		int waypoinConexion;
		double distancia;

	}conexion;

	struct Waypoins{
		double posicioncentroMX, posicioncentroMY;
		int celdaposY, celdaposX;
		int n_waypoin;
		std::list <Conexiones> conexiones;
	};

	struct PosicionOrientacionRobot{
		 double posicionX, posicionY, posicionZ;
		 double orientacionX, orientacionY, orientacionW;
		}posicionOrientacionRobot;



public:

	std::list<Waypoins > waypoins;
	void divisiones();
	void obtencionCentroCelda();
	void transformaMapa();
	void Callback(const nav_msgs::OccupancyGrid::ConstPtr& map);
    void buildDomainXml();
	void estableceConexiones();
	bool trataArgumentos(ros::NodeHandle);



	double getTamanyoXExplora() const {
		return tamanyoX_explora;
	}

	double getTamanyoYExplora() const {
		return tamanyoY_explora;
	}

	double getMetrosXreconocidos() const {
		return metrosXreconocidos;
	}

	double getMetrosYreconocidos() const {
		return metrosYreconocidos;
	}

	bool isMapacompletado() const {
		return mapacompletado;
	}

	double getMetros2reconocidos() const {
		return metros2reconocidos;
	}

	void setMetros2reconocidos(double metros2reconocidos) {
		this->metros2reconocidos = metros2reconocidos;
	}

	const char* getMensajePub() const {
		return mensaje_pub;
	}

};

#endif /* WAYPOIN_H_ */
